import 'design/style/Checkbox';

import React from 'react'
import classnames from 'classnames'
import { render } from 'react-dom'

const prefix = 'Checkbox--';

export default class Checkbox extends React.Component {

    constructor(args) {
        super(args);

        this.state = {
            labelId: 'checkbox-' + Math.random().toString('16').slice(2),
            checked: this.props.checked
        }
    }

    onChange(e) {
        this.props.onChange && this.props.onChange(e, e.target.checked);
        e.target.checked = !!!e.target.checked
        this.setState({
            checked: !!!e.target.checked
        })
    }

    render() {
        const {
            className, children, name, text, onChange,
        ...others } = this.props;

        const classes = classnames({
            'Checkbox': true,
            [className]: className
        });
        

        return (
            <label
                htmlFor={this.state.labelId}
                className = {classes}>
                <input name={name} 
                    type="checkbox"
                    {...others}
                    onChange={this.onChange.bind(this)}
                    checked={this.state.checked}
                    id={this.state.labelId}/>
                <span className="Checkbox--faux"></span>
                <span className="Form-element__label">
                { text || children }
                </span>
            </label>
        )
    }

}

Checkbox.propTypes = {
    className: React.PropTypes.string,
};

Checkbox.defaultProps = {
    onChange: () => {},
};
